【BZOJ】【2049】【SDOI2008】洞穴勘测 Cave

LCT

  哦……LCT的一道更水的裸题,适合学习access,link,cut等基本操作(其实这三个不是在一个层面上的?不要在意这些细节……)

  1 /**************************************************************
  2     Problem: 2049
  3     User: Tunix
  4     Language: C++
  5     Result: Accepted
  6     Time:1920 ms
  7     Memory:1480 kb
  8 ****************************************************************/
  9
 10 //BZOJ 2049
 11 #include<cstdio>
 12 #include<cstring>
 13 #include<cstdlib>
 14 #include<iostream>
 15 #include<algorithm>
 16 #define rep(i,n) for(int i=0;i<n;++i)
 17 #define F(i,j,n) for(int i=j;i<=n;++i)
 18 #define D(i,j,n) for(int i=j;i>=n;--i)
 19 using namespace std;
 20 const int N=10086;
 21
 22 int c[N][2],fa[N],n,m,st[N<<1],top=0;
 23 bool rev[N];
 24
 25 void Push_down(int x){
 26     int l=c[x][0],r=c[x][1];
 27     if (rev[x]){
 28         rev[x]^=1; rev[l]^=1; rev[r]^=1;
 29         swap(c[x][0],c[x][1]);
 30     }
 31 }
 32
 33 bool isroot(int x){
 34     return c[fa[x]][0]!=x && c[fa[x]][1]!=x;
 35 }
 36
 37 void rotate(int x){
 38     int y=fa[x],z=fa[y],l=c[y][1]==x,r=l^1;
 39     if (!isroot(y)) c[z][c[z][1]==y]=x;
 40     fa[x]=z; fa[y]=x; fa[c[x][r]]=y;
 41     c[y][l]=c[x][r]; c[x][r]=y;
 42 }
 43
 44 void splay(int x){
 45     top=0; st[top++]=x;
 46     for(int y=x;!isroot(y);y=fa[y])
 47         st[top++]=fa[y];
 48     while(top--) Push_down(st[top]);
 49
 50     while(!isroot(x)){
 51         int y=fa[x],z=fa[y];
 52         if (!isroot(y)){
 53             if(c[y][0]==x^c[z][0]==y) rotate(x);
 54             else rotate(y);
 55         }
 56         rotate(x);
 57     }
 58 }
 59
 60 void access(int x){
 61     for(int t=0;x;t=x,x=fa[x])
 62         splay(x),c[x][1]=t;
 63 }
 64
 65 void makeroot(int x){
 66     access(x); splay(x); rev[x]^=1;
 67 }
 68
 69 int find(int x){
 70     access(x); splay(x);
 71     while(c[x][0]) x=c[x][0];
 72     return x;
 73 }
 74
 75 void cut(int x,int y){
 76     makeroot(x);
 77     access(y);
 78     splay(y);
 79     if (c[y][0]==x) c[y][0]=fa[x]=0;
 80 }
 81
 82 void link(int x,int y){
 83     makeroot(x); fa[x]=y;
 84 }
 85 //LCT end
 86 int main(){
 87 //  freopen("input.txt","r",stdin);
 88     scanf("%d%d",&n,&m);
 89     char cmd[10];
 90     int x,y;
 91     F(i,1,m){
 92         scanf("%s%d%d",cmd,&x,&y);
 93         if (cmd[0]==‘C‘) link(x,y);
 94         else if (cmd[0]==‘D‘){
 95             if (find(x)==find(y)) cut(x,y);
 96         }
 97         else if (cmd[0]==‘Q‘){
 98             if (find(x)==find(y)) printf("Yes\n");
 99             else printf("No\n");
100         }
101     }
102     return 0;
103 }

时间: 2024-10-25 11:38:02

【BZOJ】【2049】【SDOI2008】洞穴勘测 Cave的相关文章

BZOJ 2049: [Sdoi2008]Cave 洞穴勘测

二次联通门 : BZOJ 2049: [Sdoi2008]Cave 洞穴勘测 其实指针也不是很慢 我的指针代码能吊打70%的数组 及80%的指针.... /* BZOJ 2049: [Sdoi2008]Cave 洞穴勘测 LCT 连边 删边 查询是否在同一树中时, 只需要一直向上跳 看看树根是否相同就好了 */ #include <cstdio> #include <cstdlib> #include <iostream> #define Max 400009 int

P2147 [SDOI2008]洞穴勘测

题目 P2147 [SDOI2008]洞穴勘测 做法 说实话如果你在看这篇题解的话应该也没有人劝你回去打模板吧 My complete code #include<cstdio> #include<cstring> #include<iostream> #include<string> using namespace std; typedef int LL; const LL maxn=1e6; inline LL Read(){ LL x(0),f(1);

BZOJ 2049([Sdoi2008]Cave 洞穴勘测-LCT)[Template:LCT]

2049: [Sdoi2008]Cave 洞穴勘测 Time Limit: 10 Sec  Memory Limit: 259 MB Submit: 4809  Solved: 2141 [Submit][Status][Discuss] Description 辉辉热衷于洞穴勘测.某天,他按照地图来到了一片被标记为JSZX的洞穴群地区.经过初步勘测,辉辉发现这片区域由n个洞穴(分别编号为1到n)以及若干通道组成,并且每条通道连接了恰好两个洞穴.假如两个洞穴可以通过一条或者多条通道按一定顺序连接

[BZOJ 2049] [Sdoi2008] Cave 洞穴勘测 【LCT】

题目链接:BZOJ - 2049 题目分析 LCT的基本模型,包括 Link ,Cut 操作和判断两个点是否在同一棵树内. Link(x, y) : Make_Root(x); Splay(x); Father[x] = y; Cut(x, y) : Make_Root(x); Access(y); 断掉 y 和 Son[y][0]; 注意修改 Son[y][0] 的 isRoot 和 Father 判断 x, y 是否在同一棵数内,我们就看两个点所在树的根是否相同,使用 Find_Root()

BZOJ 2049: [Sdoi2008]Cave 洞穴勘測 LCT

入门级LCT: 仅仅有 Cut Link 2049: [Sdoi2008]Cave 洞穴勘測 Time Limit: 10 Sec  Memory Limit: 259 MB Submit: 3073  Solved: 1379 [id=2049" style="color:blue; text-decoration:none">Submit][Status] Description 辉辉热衷于洞穴勘測.某天,他依照地图来到了一片被标记为JSZX的洞穴群地区.经过初步勘

BZOJ2049:[SDOI2008]洞穴勘测——题解

http://www.lydsy.com/JudgeOnline/problem.php?id=2049 https://www.luogu.org/problemnew/show/P2147 辉辉热衷于洞穴勘测. 某天,他按照地图来到了一片被标记为JSZX的洞穴群地区.经过初步勘测,辉辉发现这片区域由n个洞穴(分别编号为1到n)以及若干通道组成,并且每条通道连接了恰好两个洞穴.假如两个洞穴可以通过一条或者多条通道按一定顺序连接起来,那么这两个洞穴就是连通的,按顺序连接在一起的这些通道则被称之为

BZOJ 2049 [Sdoi2008]Cave 洞穴勘测 LCT

题意:链接 方法: LCT 解析: 搞了一下午的LCT,这道题就当做第一道模板?题.然后大概写个理解总结什么的. 首先!splay不要写挂!不要写挂! 然后对于这道题.没有什么奇怪的操作. 只有两个操作,将两个节点连起来,将两个节点之间的连边断开. 每一次询问,询问两个节点是否连通. 听起来挺简单的,一下子就想到了并查集有没有! 然而发现并查集并不可以搞. 也许是我太弱,但是我真的不会并查集的分割. 所以还是老老实实来想LCT. LCT 顾名思义,Link Cut 是其比较有代表性的操作? 首先

BZOJ2049 SDOI2008 洞穴勘测 LCT

题意:给定一棵树,维护:1.删除一条边  2.添加一条边  3.询问u和v是否连通 题解:LCT维护连通性 #include <cstdio> #include <cstring> #include <cstdlib> #include <iostream> #include <algorithm> using namespace std; const int MAXN=10000+2; typedef struct NODE{ NODE *ch

BZOJ-2049 [Sdoi2008]洞穴勘测

LCT模版题.... #include <cstdlib> #include <cstdio> #include <cstring> #include <algorithm> #include <iostream> #include <cctype> #include <cmath> #define rep(i, l, r) for(int i=l; i<=r; i++) #define clr(x, c) mems